/*   GALACTICOMM Major BBS user account header file                        */
/*   Copyright (C) 1987-1989 GALACTICOMM, Inc.    All Rights Reserved.     */
 
#define UIDSIZ 10             /* user-id size (including trailing zero)    */
#define PSWSIZ 10             /* password size (ditto)                     */
#define NADSIZ 30             /* name/address line size (ditto)            */
#define PHOSIZ 16             /* phone number field size (ditto)           */
#define DATSIZ 10             /* date size (ditto, plus 1 for alignment)   */
#define USRACCSPARE (252-206) /* spare space, decrease when adding entries */
 
struct usracc {
     char userid[UIDSIZ];     /* user-id                                   */
     char psword[PSWSIZ];     /* password                                  */
     char usrnam[NADSIZ];     /* user name                                 */
     char usrad1[NADSIZ];     /* address line 1 (company)                  */
     char usrad2[NADSIZ];     /* address line 2                            */
     char usrad3[NADSIZ];     /* address line 3                            */
     char usrpho[PHOSIZ];     /* phone number                              */
     char systyp;             /* system type code                          */
     char ansifl;             /* ANSI flags                                */
     char scnwid;             /* screen width in columns                   */
     char scnlen;             /* screen length in lines                    */
     int age;                 /* user's age                                */
     int sex;                 /* user's sex ('M' or 'F')                   */
     char credat[DATSIZ];     /* account creation date                     */
     char usedat[DATSIZ];     /* date of last use of account               */
     long frescu;             /* free seconds used to date                 */
     long tcktot;             /* total "live" seconds credited             */
     long tckpai;             /* portion of "live" seconds paid for        */
     long tckavl;             /* "live" seconds available at the moment    */
     int csicnt;              /* classified-ad counts used so far          */
     char spare[USRACCSPARE]; /* spare space, for graceful upgrades        */
     long emllim;             /* e-mail limit reached so far (new/old bdy) */
};
 
                              /* ansifl bit definitions                    */
#define ANSON  1              /*   ANSI on=1; off=0                        */
#define ANSMAN 2              /*   ANSI manual override (0=auto sensing)   */
 
extern
struct usracc *usracc,        /* user accounting block array               */
              *usaptr,        /* user accounting block pointer for usrnum  */
              *othuap;        /* gen purp other-user accounting data ptr   */
 
